/********************************************************************
2/22@OK
 *******************************************************************/

/** INCLUDES *******************************************************/
#include <system.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stddef.h>
#include <usb/usb.h>
#include <app_led_usb_status.h>
#include <app_device_cdc_basic.h>
#include <usb_config.h>

/** VARIABLES ******************************************************/

static uint8_t readBuffer[CDC_DATA_OUT_EP_SIZE];
static uint8_t writeBuffer[CDC_DATA_IN_EP_SIZE];

/** ԊOMŎgpϐ ***************************************/
static unsigned char Mk_Buffer[MaxBits];
static unsigned char Sp_Buffer[MaxBits];
static unsigned char IrMsg[16];
static char IrState;
static char TxState;
static char PtrSend;
static char NumBit;
static unsigned int period;
static unsigned int M_Leader;
static unsigned int S_Leader;

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInitialize(void);
* Overview: Initializes the demo code
* PreCondition: None
* Input: None
* Output: None
********************************************************************/
void APP_DeviceCDCBasicDemoInitialize(){
    CDCInitEP();
    
    line_coding.bCharFormat = 0;
    line_coding.bDataBits = 8;
    line_coding.bParityType = 0;
    line_coding.dwDTERate = 9600;

    //------------- LED --------------------
    TRISCbits.TRISC2 = 0;      // LED Output
    // ----------- Timer1  -----------
    T1CON = 0b00100001;        // 22mSecFOSC/4 PS_1/4
    T1GCON = 0;
    PIR1bits.TMR1IF = 0;
    PIE1bits.TMR1IE = 1;
    // ----------- Timer2  -----------
    T2CON = 0b00111110;        // 2.7mSec PS_1/16 Post1/8    
    PIR1bits.TMR2IF = 0;
    PIE1bits.TMR2IE = 1;
    // ----------- Pin ԕω  -----------
    IOCBNbits.IOCBN7 = 1;        // ɐ̕ψقŊ
    IOCBPbits.IOCBP7 = 1;
    IOCBFbits.IOCBF7 = 0;
    INTCONbits.IOCIE = 1;

    TxState = TxIrStandBy;
    IrState = IrWaiting;
    
    INTCONbits.PEIE = 1;              // Ӌ@\݂̎gp
    INTCONbits.GIE  = 1;              // S݂̎gp
}

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoTasks(void);
* Overview: Keeps the demo running.
* PreCondition: The demo should have been initialized and started via
*   the APP_DeviceCDCBasicDemoInitialize() and APP_DeviceCDCBasicDemoStart() demos
*   respectively.
* Input: None
* Output: None
********************************************************************/
void APP_DeviceCDCBasicDemoTasks(){
    unsigned int Mk;
    unsigned int Sp;

    // MR[hUSBM  *************
    if( USBUSARTIsTxTrfReady() == true){
        switch(TxState){
        case TxIrStandBy:                // TxIrStandBy
            break;
        case TxIrStart:                  // xso
            putrsUSBUSART("> Mark  Space (uS)\r\n");
            PtrSend=0;
            TxState = TxIrLeader;
            break;
        case TxIrLeader:                 // IRM[_񑗏o
            sprintf(IrMsg,"%6d,%6d\r\n",M_Leader*10,S_Leader*10);
            putUSBUSART(IrMsg,15);
            TxState = TxIrData;
            break;
        case TxIrData:                   // IRMf[^񑗏o
            Mk = (unsigned int)Mk_Buffer[PtrSend]*10;
            Sp = (unsigned int)Sp_Buffer[PtrSend]*10;
            sprintf(IrMsg,"%6d,%6d\r\n",Mk,Sp);
            putUSBUSART(IrMsg,15);
            if(++PtrSend >= NumBit){
                TxState = TxIrDone;
            }
            break;                       // IRM񑗏o
        case TxIrDone:
            putrsUSBUSART("<\r\n");
            TxState = TxIrStandBy;
            IrState = IrWaiting;
            IOCBFbits.IOCBF7 = 0;
            INTCONbits.IOCIE = 1;
            break;
        } // switch
    }
    CDCTxService();
}

/*********************************************************************
* Function: void APP_Interrupt(void);
* Overview: ݂̔Ɏs
* PreCondition: ݂̐ݒ the APP_DeviceCDCBasicDemoInitialize()
* ōs
* Input: None
* Output: None
********************************************************************/
void APP_Interrupt(void){
    char IrRcv;
    if(FlagIr){
        period = TMR1;                   // oߎԎ擾
        TMR1 = 0;                        // oߎԃZbg
        period /= 30;                    // Ԃ10SPʂɕϊ
        LED_RC2 = 1;                     // IrMLEDɕ\
        IrRcv = IrIN;
        // -----------------------------
        switch(IrState){
        case IrIdle:        // --- IRACh -------------------------
            break;
        case IrWaiting:      // --- IR̓͑҂ -------------------------
            if(!IrRcv){                    // SpaceMark ւ̕ψʂȂ
                NumBit = 0;                // Dataobt@
                IrState = IrLeaderMark;    //   ɐi
            }
            break;
        case IrLeaderMark:   // --- [_E}[NIŊ -------------
            M_Leader = period;           // }[Nԕۑ
            if(M_Leader > 200)           // }[N2mSȏȂ
                IrState = IrLeaderSpace; //    ɐi
            else                         // 2mS̓mCYȂ̂
                IrState = IrWaiting;     //    Waitingɖ߂
            break;
        case IrLeaderSpace:  // --- [_EXy[XIŊ -----------
            S_Leader = period;           // Xy[XԂۑ
                TMR2 = 0;                //   Ȉ
                FlagT2 = 0;              //   tONA
                OnT2 = 1;                //   Timer2X^[g
                IrState = IrDataMark;    //   ɐi
            break;
        case IrDataMark:      // --- f[^E}[NIŊ -------------
            Mk_Buffer[NumBit] = period;  // Markԕۑ
            TMR2 = 0;                    // I胊Zbg
            IrState = IrDataSpace;       // ɐi
            break;
        case IrDataSpace:     // --- f[^EXy[XIŊ -------------
            Sp_Buffer[NumBit++] = period;  // Spaceԕۑ
            if(NumBit >= MaxBits){       // obt@tȂ
                IrState = IrIdle;        // I
                TxState = TxIrStart;      // USBőM
                OnT2 = 0;                 // Timer2~
                FlagT2 = 0;               // tbONA
            }else{                       // ܂A]TȂ
                TMR2 = 0;                //   I胊Zbg
                IrState = IrDataMark;    //   ɐi
            }
            break;
        }
        // -----------------------------
       IOCBFbits.IOCBF7 = 0;             // tbONA
    }
    // -------Timer1 ɂMIo----------------------
    if(PIR1bits.TMR1IF){
        PIR1bits.TMR1IF = 0;
        LED_RC2 = 0;
    }
    // -------Timer2 ɂMIo----------------------
    if(FlagT2){
        Sp_Buffer[NumBit++] = 0;         // IBit
        IrState = IrIdle;                // I
        TxState = TxIrStart;             // USBőM
        OnT2 = 0;                        // Timer2~
        FlagT2 = 0;                      // tbONA
    }
}
