/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

#ifndef APP_DEVICE_CDC_BASIC_H
#define APP_DEVICE_CDC_BASIC_H

#include <stdbool.h>
#include <stddef.h>

#include <usb/usb_device_cdc.h>

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInitialize(void);
*
* Overview: Initializes the demo code
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoInitialize();

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoTasks(void);
*
* Overview: Keeps the demo running.
*
* PreCondition: The demo should have been initialized and started via
*   the APP_DeviceCDCBasicDemoInitialize() and APP_DeviceCDCBasicDemoStart() demos
*   respectively.
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoTasks();


/*********************************************************************
* ԊOMŎgp`
*
********************************************************************/

#define IrIN      PORTBbits.RB7      // ԊO
#define FlagIr    INTCONbits.IOCIF   // ͕ψʃtbO

#define FlagT2    PIR1bits.TMR2IF    // EL[tbO
#define PrioT2    IPR1bits.TMR2IP    // D抄
#define OnT2      T2CONbits.TMR2ON   // Timer2ON/OFF
#define LED_RC2   LATCbits.LATC2
#define MaxBits   80

// IrStateŎgpXe[g
#define IrIdle             0           // IRACh
#define IrWaiting          1           // IR͑҂
#define IrLeaderMark       2           // IR[_@}[N@
#define IrLeaderSpace      3           // IR[_@Xy[X
#define IrDataMark         4           // IRf[^@}[N@
#define IrDataSpace        5           // IRf[^@Xy[X
#define IrReceived         6           // IRM

// TxStateŎgpXe[g
#define TxIrStandBy        0           // USBoX^oC
#define TxIrStart          1           // xso
#define TxIrLeader         2           // IRM[_񑗏o
#define TxIrData           3           // IRMf[^񑗏o
#define TxIrDone           4           // IRM񑗏o
#define TxIrEnd            5           // IR
#define TxLabel            6           // IR

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInterrupt(void);
* Overview: ݂̔Ɏs
* PreCondition: ݂̐ݒ the APP_DeviceCDCBasicDemoInitialize()
* ōs
* Input: None
* Output: None
********************************************************************/
void APP_Interrupt(void);
#endif
